if(NOT DEFINED SODIUM_SRC)
  set(SODIUM_SRC ${CMAKE_CURRENT_LIST_DIR}/libsodium/src/libsodium)
endif()

include_directories(${CMAKE_CURRENT_LIST_DIR}/sodium-config)
include_directories(${CMAKE_CURRENT_LIST_DIR}/sodium-config/sodium)
include_directories(${SODIUM_SRC}/include)

add_library(sodium STATIC
${SODIUM_SRC}/randombytes/sysrandom/randombytes_sysrandom.c
${SODIUM_SRC}/randombytes/nativeclient/randombytes_nativeclient.c
${SODIUM_SRC}/randombytes/salsa20/randombytes_salsa20_random.c
${SODIUM_SRC}/randombytes/randombytes.c
${SODIUM_SRC}/crypto_generichash/blake2b/ref/blake2b-compress-ref.c
${SODIUM_SRC}/crypto_generichash/blake2b/ref/generichash_blake2b.c
${SODIUM_SRC}/crypto_generichash/blake2b/ref/blake2b-compress-sse41.c
${SODIUM_SRC}/crypto_generichash/blake2b/ref/blake2b-compress-avx2.c
${SODIUM_SRC}/crypto_generichash/blake2b/ref/blake2b-ref.c
${SODIUM_SRC}/crypto_generichash/blake2b/ref/blake2b-compress-ssse3.c
${SODIUM_SRC}/crypto_generichash/blake2b/generichash_blake2.c
${SODIUM_SRC}/crypto_generichash/crypto_generichash.c
${SODIUM_SRC}/crypto_sign/crypto_sign.c
${SODIUM_SRC}/crypto_sign/ed25519/sign_ed25519.c
${SODIUM_SRC}/crypto_sign/ed25519/ref10/open.c
${SODIUM_SRC}/crypto_sign/ed25519/ref10/obsolete.c
${SODIUM_SRC}/crypto_sign/ed25519/ref10/sign.c
${SODIUM_SRC}/crypto_sign/ed25519/ref10/keypair.c
${SODIUM_SRC}/crypto_pwhash/argon2/argon2-fill-block-avx2.c
${SODIUM_SRC}/crypto_pwhash/argon2/pwhash_argon2id.c
${SODIUM_SRC}/crypto_pwhash/argon2/blake2b-long.c
${SODIUM_SRC}/crypto_pwhash/argon2/pwhash_argon2i.c
${SODIUM_SRC}/crypto_pwhash/argon2/argon2-encoding.c
${SODIUM_SRC}/crypto_pwhash/argon2/argon2.c
${SODIUM_SRC}/crypto_pwhash/argon2/argon2-core.c
${SODIUM_SRC}/crypto_pwhash/argon2/argon2-fill-block-avx512f.c
${SODIUM_SRC}/crypto_pwhash/argon2/argon2-fill-block-ref.c
${SODIUM_SRC}/crypto_pwhash/argon2/argon2-fill-block-ssse3.c
${SODIUM_SRC}/crypto_pwhash/scryptsalsa208sha256/pwhash_scryptsalsa208sha256.c
${SODIUM_SRC}/crypto_pwhash/scryptsalsa208sha256/scrypt_platform.c
${SODIUM_SRC}/crypto_pwhash/scryptsalsa208sha256/crypto_scrypt-common.c
${SODIUM_SRC}/crypto_pwhash/scryptsalsa208sha256/pbkdf2-sha256.c
${SODIUM_SRC}/crypto_pwhash/scryptsalsa208sha256/sse/pwhash_scryptsalsa208sha256_sse.c
${SODIUM_SRC}/crypto_pwhash/scryptsalsa208sha256/nosse/pwhash_scryptsalsa208sha256_nosse.c
${SODIUM_SRC}/crypto_pwhash/crypto_pwhash.c
${SODIUM_SRC}/crypto_shorthash/crypto_shorthash.c
${SODIUM_SRC}/crypto_shorthash/siphash24/shorthash_siphash24.c
${SODIUM_SRC}/crypto_shorthash/siphash24/ref/shorthash_siphash24_ref.c
${SODIUM_SRC}/crypto_shorthash/siphash24/ref/shorthash_siphashx24_ref.c
${SODIUM_SRC}/crypto_shorthash/siphash24/shorthash_siphashx24.c
${SODIUM_SRC}/crypto_auth/hmacsha256/auth_hmacsha256.c
${SODIUM_SRC}/crypto_auth/hmacsha512/auth_hmacsha512.c
${SODIUM_SRC}/crypto_auth/crypto_auth.c
${SODIUM_SRC}/crypto_auth/hmacsha512256/auth_hmacsha512256.c
${SODIUM_SRC}/crypto_stream/chacha20/dolbeau/chacha20_dolbeau-ssse3.c
${SODIUM_SRC}/crypto_stream/chacha20/dolbeau/chacha20_dolbeau-avx2.c
${SODIUM_SRC}/crypto_stream/chacha20/stream_chacha20.c
${SODIUM_SRC}/crypto_stream/chacha20/ref/chacha20_ref.c
${SODIUM_SRC}/crypto_stream/aes128ctr/nacl/stream_aes128ctr_nacl.c
${SODIUM_SRC}/crypto_stream/aes128ctr/nacl/xor_afternm_aes128ctr.c
${SODIUM_SRC}/crypto_stream/aes128ctr/nacl/afternm_aes128ctr.c
${SODIUM_SRC}/crypto_stream/aes128ctr/nacl/consts_aes128ctr.c
${SODIUM_SRC}/crypto_stream/aes128ctr/nacl/beforenm_aes128ctr.c
${SODIUM_SRC}/crypto_stream/aes128ctr/nacl/int128_aes128ctr.c
${SODIUM_SRC}/crypto_stream/aes128ctr/stream_aes128ctr.c
${SODIUM_SRC}/crypto_stream/crypto_stream.c
${SODIUM_SRC}/crypto_stream/salsa2012/ref/stream_salsa2012_ref.c
${SODIUM_SRC}/crypto_stream/salsa2012/stream_salsa2012.c
${SODIUM_SRC}/crypto_stream/salsa20/xmm6int/salsa20_xmm6int-avx2.c
${SODIUM_SRC}/crypto_stream/salsa20/xmm6int/salsa20_xmm6int-sse2.c
${SODIUM_SRC}/crypto_stream/salsa20/ref/salsa20_ref.c
${SODIUM_SRC}/crypto_stream/salsa20/stream_salsa20.c
${SODIUM_SRC}/crypto_stream/salsa20/xmm6/salsa20_xmm6.c
${SODIUM_SRC}/crypto_stream/xsalsa20/stream_xsalsa20.c
${SODIUM_SRC}/crypto_stream/salsa208/ref/stream_salsa208_ref.c
${SODIUM_SRC}/crypto_stream/salsa208/stream_salsa208.c
${SODIUM_SRC}/crypto_stream/xchacha20/stream_xchacha20.c
${SODIUM_SRC}/crypto_kdf/crypto_kdf.c
${SODIUM_SRC}/crypto_kdf/blake2b/kdf_blake2b.c
${SODIUM_SRC}/crypto_verify/sodium/verify.c
${SODIUM_SRC}/crypto_hash/sha512/hash_sha512.c
${SODIUM_SRC}/crypto_hash/sha512/cp/hash_sha512_cp.c
${SODIUM_SRC}/crypto_hash/sha256/hash_sha256.c
${SODIUM_SRC}/crypto_hash/sha256/cp/hash_sha256_cp.c
${SODIUM_SRC}/crypto_hash/crypto_hash.c
${SODIUM_SRC}/crypto_aead/xchacha20poly1305/sodium/aead_xchacha20poly1305.c
${SODIUM_SRC}/crypto_aead/aes256gcm/aesni/aead_aes256gcm_aesni.c
${SODIUM_SRC}/crypto_aead/chacha20poly1305/sodium/aead_chacha20poly1305.c
${SODIUM_SRC}/crypto_kx/crypto_kx.c
${SODIUM_SRC}/crypto_scalarmult/curve25519/sandy2x/curve25519_sandy2x.c
${SODIUM_SRC}/crypto_scalarmult/curve25519/sandy2x/fe_frombytes_sandy2x.c
${SODIUM_SRC}/crypto_scalarmult/curve25519/sandy2x/fe51_invert.c
${SODIUM_SRC}/crypto_scalarmult/curve25519/scalarmult_curve25519.c
${SODIUM_SRC}/crypto_scalarmult/curve25519/ref10/x25519_ref10.c
${SODIUM_SRC}/crypto_scalarmult/curve25519/donna_c64/curve25519_donna_c64.c
${SODIUM_SRC}/crypto_scalarmult/crypto_scalarmult.c
${SODIUM_SRC}/crypto_onetimeauth/poly1305/donna/poly1305_donna.c
${SODIUM_SRC}/crypto_onetimeauth/poly1305/sse2/poly1305_sse2.c
${SODIUM_SRC}/crypto_onetimeauth/poly1305/onetimeauth_poly1305.c
${SODIUM_SRC}/crypto_onetimeauth/crypto_onetimeauth.c
${SODIUM_SRC}/crypto_secretstream/xchacha20poly1305/secretstream_xchacha20poly1305.c
${SODIUM_SRC}/sodium/utils.c
${SODIUM_SRC}/sodium/codecs.c
${SODIUM_SRC}/sodium/core.c
${SODIUM_SRC}/sodium/version.c
${SODIUM_SRC}/sodium/runtime.c
${SODIUM_SRC}/crypto_secretbox/crypto_secretbox_easy.c
${SODIUM_SRC}/crypto_secretbox/xchacha20poly1305/secretbox_xchacha20poly1305.c
${SODIUM_SRC}/crypto_secretbox/crypto_secretbox.c
${SODIUM_SRC}/crypto_secretbox/xsalsa20poly1305/secretbox_xsalsa20poly1305.c
${SODIUM_SRC}/crypto_box/crypto_box_seal.c
${SODIUM_SRC}/crypto_box/crypto_box_easy.c
${SODIUM_SRC}/crypto_box/curve25519xchacha20poly1305/box_seal_curve25519xchacha20poly1305.c
${SODIUM_SRC}/crypto_box/curve25519xchacha20poly1305/box_curve25519xchacha20poly1305.c
${SODIUM_SRC}/crypto_box/crypto_box.c
${SODIUM_SRC}/crypto_box/curve25519xsalsa20poly1305/box_curve25519xsalsa20poly1305.c
${SODIUM_SRC}/crypto_core/curve25519/ref10/curve25519_ref10.c
${SODIUM_SRC}/crypto_core/hchacha20/core_hchacha20.c
${SODIUM_SRC}/crypto_core/salsa/ref/core_salsa_ref.c
${SODIUM_SRC}/crypto_core/hsalsa20/ref2/core_hsalsa20_ref2.c
${SODIUM_SRC}/crypto_core/hsalsa20/core_hsalsa20.c)

target_compile_options(sodium PRIVATE -DCONFIGURED=1)
target_include_directories(sodium PRIVATE ${SODIUM_SRC}/include/sodium/)
